package org.josast.equationKepler;

/**
 * <b>Description : Interface use for kepler Equation</b>
 * 
 * <p>
 * Projet : JOSAST <BR><br>
 * <b>JOSAST</b> : Java Open Source Amateur Satellite  Toolbox  <br>
 * The aim of the project is to create a set of tools for amateur
 * satellite purpose. All this tools could be used together to create
 * specific software. <b>JOSAST</b> project is managed by AVMDTI (<A
 * HREF="http://www.avmdti.org">http://www.avmdti.org </a> ) <br>
 * This software is an open source software. Please read the <b><i>JOSAST
 * licence</i></b><BR>(<A
 * HREF="http://www.avmdti.org">http://www.avmdti.org </a> )
 * </p>
 * 
 * <p>
 * for more information contact <a href="mailto:josast@avmdti.org">josast
 * at avmdti.org</a>
 * </p>
 *
 * @author <a href="mailto:mercier.josast@avmdti.org">mercier</a>
 * @version 1.0 <p><p>
 */
public interface Kepler {
    //~ Methods -----------------------------------------------------------

    /**
     * Method Calcul. Solve the Kepler Equation
     *
     * @param meanAnomaly mean anomalie in radian
     * @param eccentricity exentricity
     *
     * @return double
     */
    double calcul(double meanAnomaly, double eccentricity);

    /**
     * Method getEpsilon.
     *
     * @return double return the accuracy of the solver
     */
    double getEpsilon();

    /**
     * Method setEpsilon.
     *
     * @param epsilon accuracy of the solver
     */
    void setEpsilon(double epsilon);
}
